This is a cumulative patch of all the patches released for ircd-ratbox-2.0.8
upto this date.

To apply this diff:
  cd SRC
  patch -p0 < ircd-ratbox-2.0.8+patchset-20050509.diff

Then compile as normal.

diff -ur modules/core/m_mode.c modules-new/core/m_mode.c
--- modules/core/m_mode.c	2005-01-28 20:25:14.000000000 +0000
+++ modules-new/core/m_mode.c	2005-05-09 13:49:17.955215604 +0000
@@ -355,6 +355,10 @@
 
 	while(s != NULL)
 	{
+		/* ban with a leading ':' -- this will break the protocol */
+		if(*s == ':')
+			goto nextban;
+
 		tlen = strlen(s);
 
 		/* I dont even want to begin parsing this.. */
@@ -385,6 +389,7 @@
 			modecount++;
 		}
 
+nextban:
 		s = t;
 
 		if(s != NULL)
@@ -695,7 +700,7 @@
 	for (s = t = (u_char *) arg; (c = *s); s++)
 	{
 		c &= 0x7f;
-		if((c != 0x0a) && (c != ':') && (c != 0x0d))
+		if((c != 0x0a) && (c != ':') && (c != 0x0d) && (c != ' '))
 			*t++ = c;
 	}
 
@@ -881,7 +886,12 @@
 		return;
 
 	if(!MyClient(source_p))
+	{
+		if(strchr(raw_mask, ' '))
+			return;
+		
 		mask = raw_mask;
+	}
 	else
 		mask = pretty_mask(raw_mask);
 
@@ -1169,14 +1179,14 @@
 		key = LOCAL_COPY(parv[(*parn)]);
 		(*parn)++;
 
-		if(EmptyString(key))
-			return;
-
 		if(MyClient(source_p))
 			fix_key(key);
 		else
 			fix_key_remote(key);
 
+		if(EmptyString(key))
+			return;
+
 		s_assert(key[0] != ' ');
 		strlcpy(chptr->mode.key, key, sizeof(chptr->mode.key));
 
diff -ur modules/m_resv.c modules-new/m_resv.c
--- modules/m_resv.c	2004-12-04 21:28:50.000000000 +0000
+++ modules-new/m_resv.c	2005-05-09 13:49:09.988056974 +0000
@@ -405,10 +405,10 @@
 	/* parv[0]  parv[1]        parv[2]
 	 * oper     target server  resv to remove
 	 */
-	propagate_generic(source_p, "UNRESV", parv[3], CAP_CLUSTER,
+	propagate_generic(source_p, "UNRESV", parv[1], CAP_CLUSTER,
 			"%s", parv[2]);
 
-	if(!match(me.name, parv[1]))
+	if(!match(parv[1], me.name))
 		return 0;
 
 	if(!IsPerson(source_p))
diff -ur modules/m_xline.c modules-new/m_xline.c
--- modules/m_xline.c	2005-01-14 22:10:40.000000000 +0000
+++ modules-new/m_xline.c	2005-05-09 13:49:06.949996485 +0000
@@ -494,7 +494,7 @@
 	/* parv[0]  parv[1]        parv[2]
 	 * oper     target server  gecos
 	 */
-	propagate_generic(source_p, "UNXLINE", parv[3], CAP_CLUSTER,
+	propagate_generic(source_p, "UNXLINE", parv[1], CAP_CLUSTER,
 			"%s", parv[2]);
 
 	if(!match(parv[1], me.name))
